<template>
  <div class="antialiased font-nunito bg-white p-4">
    <BreadCrumb />
    <div class="w-full h-auto py-4" v-if="$route.params.slug === 'fashion'">
      <h1 class="text-2xl font-semibold text-gray-800">moda</h1>

      <div class="grid grid-cols-2 lg:flex lg:flex-row md:flex-row flex-col gap-4 mt-4 h-64">
        <div class="box-header">
          <nuxt-link :to="localePath({ name: 'categories-slug', params: { slug: 'man' } })">
            <div class="flex items-stretch absolute pl-6 align-text-bottom bottom-0 -ml-4 py-1 md:py-4 lg:py-8 w-full h-full"><span class="flex self-end text-3xl font-bold text-gray-800"><span class="underline">m</span>asculino</span></div>
          </nuxt-link>
        </div>
        <div class="box-header">
          <nuxt-link :to="localePath({ name: 'categories-slug', params: { slug: 'woman' } })">
            <div class="flex items-stretch absolute pl-6 align-text-bottom bottom-0 -ml-4 py-1 md:py-4 lg:py-8 w-full h-full"><span class="flex self-end text-3xl font-bold text-gray-800"><span class="underline">f</span>eminino</span></div>
          </nuxt-link>
        </div>
        <div class="box-header">
          <div class="flex items-stretch absolute pl-6 align-text-bottom bottom-0 -ml-4 py-1 md:py-4 lg:py-8 w-full h-full"><span class="flex self-end text-3xl font-bold text-gray-800"><span class="underline">e</span>sporte</span></div>
        </div>
        <div class="box-header">
          <nuxt-link :to="localePath({ name: 'categories-slug', params: { slug: 'kids' } })">
            <div class="flex items-stretch absolute pl-6 align-text-bottom bottom-0 -ml-4 py-1 md:py-4 lg:py-8 w-full h-full"><span class="flex self-end text-3xl font-bold text-gray-800"><span class="underline">i</span>nfantil</span></div>
          </nuxt-link>
        </div>
      </div>
    </div>
    <div class="lg:flex lg:flex-row w-full">
      <div class="lg:block w-1/4 py-4 hidden">
        <span class="text-lg font-semibold text-gray-800 my-4" v-if="filteredCategories[$route.params.slug]">categorias</span>
          <ul>
            <li v-for="(category, index) in categories" :key="index">
                <nuxt-link
                  :to="category.slug"
                  :class="$route.params.slug === category.slug ? 'is-active' : ''"
                  class="lowercase text-sm text-gray-700 my-4"
                >
                  {{ category.name }}
                </nuxt-link>
            </li>
          </ul>
      </div>
      <div v-if="products.length">
        <div class="flex flex-col w-full mx-auto lg:my-4 my-8" v-if="$route.params.slug === 'man-clothes'">
          <h1 class="w-full h-full top-0 text-2xl font-semibold text-gray-800">os mais vendidos desta categoria</h1>
          <div class="w-full my-4"><ProductSlide :products="products" /></div>
        </div>
        <!-- grid lg:grid-cols-4 md:grid-cols-3 grid-cols-2 -->
        <div v-else class="flex flex-row w-full bg-gray-400 mx-auto lg:my-4 my-8" v-for="product in products"
        :key="product.slug">
            <div class="flex flex-row"><Product :product="product" /></div>
        </div>
      </div>
      <div v-else class="flex justify-center rounded-lg align-center items-center w-full h-auto bg-gray-100 lg:my-4 my-8">
        <span class="font-semibold text-gray-800">Nenhum produto desta categoria</span>
      </div>
    </div>
  </div>
</template>

<script>
import Product from '@/components/products/Product'
import BreadCrumb from '@/components/app/BreadCrumb'
import ProductSlide from '@/components/products/ProductSlide'

export default {

  data () {
      return {
        slug: this.$route.params.slug,
        products: [],
        filteredCategories: []
      }
  },

  components: {
        Product,
        BreadCrumb,
        ProductSlide
    },

    created() {
      let categories = this.$store.state.categories;

      categories.forEach(category => {
        this.filteredCategories[category.slug] = { ...category.children }
        if (category.children.length) {
          category.children.forEach(child => {
            this.filteredCategories[child.slug] = { ...child.children }
            if (child.children.length) {
              child.children.forEach(subChild => {
                this.filteredCategories[subChild.slug] = { ...subChild.children }
                // if (subChild.children.length) {
                //   subChild.children.forEach(subsubChild => {
                //     this.filteredCategories[subsubChild.slug] = { parent: subsubChild.children, ...subsubChild.children }
                //   })
                // }
              })
            }
          })
        }
      })
    },

    async mounted() {
      let parentCategory = null
      let breadcrumbs = []

      if (this.slug) {
          parentCategory =  await this.$axios.$get(`/api/categories/${this.slug}`)

          if (parentCategory.data && parentCategory.data.parent) {
            let subParentCategory =  await this.$axios.$get(`/api/categories/${parentCategory.data.parent.slug}`)
            if (subParentCategory.data && subParentCategory.data.parent) {
                let subsubParentCategory =  await this.$axios.$get(`/api/categories/${subParentCategory.data.parent.slug}`)
                if (subsubParentCategory.data.parent) {
                  breadcrumbs.push({ name: subsubParentCategory.data.parent.name, slug: subsubParentCategory.data.parent.slug})
                }
                breadcrumbs.push({ name: subsubParentCategory.data.name, slug: subsubParentCategory.data.slug})
            }
            breadcrumbs.push({ name: parentCategory.data.parent.name, slug: parentCategory.data.parent.slug})
            breadcrumbs.push({ name: parentCategory.data.name, slug: parentCategory.data.slug})

          } else {
            breadcrumbs.push({ name: parentCategory.data.name, slug: parentCategory.data.slug})
          }
        }
        this.$store.commit('SET_BREADCRUMBS', [
          ...breadcrumbs,
          // { name: this.filteredCategories[this.$route.params.slug][0].parent.name, slug: this.filteredCategories[this.$route.params.slug][0].parent.slug },
        ])


      this.$store.commit('SET_FILTERED_CATEGORIES', this.filteredCategories[this.slug])
    },

    computed: {
        categories() {
            return this.filteredCategories[this.slug]
        },
    },

    methods: {

    },

    async asyncData({ params, app }){
      let response = await app.$axios.$get(`/api/products`, {
          params: {
              category: params.slug
          }
      })

      return {
          products: response.data
      }
    }
}
</script>

<style lang="postcss" scoped>
    .category-children {
        padding-left: 1rem;
    }

    .card {
        padding: 1rem;
    }

    @media screen and (max-width: 720px){
        .is-sidebar {
            display: none;
        }
    }

  .box-header {
    @apply relative flex w-full h-full items-center bg-secondary px-4
  }
</style>
